"""
 (C) Copyright 2002 Kapil Thangavelu <kvthan@wm.edu>
 All Rights Reserved

 This file is part of Gideon.

 Gideon is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Gideon is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Gideon; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""

# $Id: $

import Pep241Parser
import PPDParser

_plookup = {}

def register_parser(type, kind, parser_factory):
    _plookup[(type,kind)]=parser_factory    
    
def supported_formats(obj):
    res = []
    for f, k in _plookup.keys():
        if f not in res: res.append(f)
    return res

def parse(type, kind, file):
    factory = _plookup.get((type,kind), None)
    if factory is None: raise "No Factory For this MetaType"
    return factory(file)

register_parser('PEP241', 'file', Pep241Parser.parse_file)
register_parser('PEP241', 'string', Pep241Parser.parse_string)
register_parser('PEP241', 'url', Pep241Parser.parse_url)
register_parser('PEP241', 'stream', Pep241Parser.parse_stream)
