class PackageAdmin(SimpleItem, Implicit):
    
    """
    adminstrative interface, this should
    contain most of the state dependent behavior, 
    its a kludge and i know it.
    
    ideally this class gives state and role dependent views
    to manage a package. it is mainly a presentation class
    although it contains partial logic for state changes.
    
    this would be much cleaner split up into a full state machine.
    which is what PackageWorkflow.py has the start of.
    """
    
    index_html = DTMLFile('ui/PackageAdminView', globals())
    
    edit_package_info_form = DTMLFile('ui/PackageAdminEditInfoForm',globals())
    edit_package_versions_form = DTMLFile('ui/PackageAdminEditVersionsForm', globals())
    edit_package_dependencies_form = DTMLFile('ui/PackageAdminEditDependenciesForm', globals())
    edit_package_approve_form = DTMLFile('ui/PackageAdminApproveForm', globals())
    edit_package_categories_form = DTMLFile('ui/PackageAdminEditCategories', globals())

    view_package_history = DTMLFile('ui/PackageHistoryView', globals())
    
    _widget_for_queue = DTMLFile('ui/PackageAdminQueueWidget',globals())
    _widget_for_published = DTMLFile('ui/PackageAdminPublishedWidget',globals())
    _menu_for_published = DTMLFile('ui/PackageAdminPublishedMenu',globals())
    
    def __init__(self,
                 id = 'Admin'
            ):
        self.id = id
        self._state = ''
        
    def get_admin_widget(self):
        """this gets called from the package view """
        package = self.aq_inner.aq_parent
        if package._published:
            return self._widget_for_published(self, self.REQUEST)
        else:
            return self._widget_for_queue(self, self.REQUEST)

    def get_admin_menu(self):
        """ this gets called from the admin view """
        package = self.aq_inner.aq_parent        
        if package._published:
            return self._menu_for_published(self, self.REQUEST)
        else:
            return self._widget_for_queue(self, self.REQUEST)            
    
        
    # submit methods
        
    def edit_package_approve(self, REQUEST):
        """ """
        contract = """
        #parameters
        package_notes:optional, trim, nohtml
        """
        contract = compile(contract)
        contract.validate(self)
        
        #if REQUEST.has_key('package_notes'):
        #    package_notes = REQUEST['package_notes']
         
        pid = self.get_package_info().package_name()
        log.debug('approving package (%s) in queue'%pid)

        queue = self.get_inner_application(self)
        package = aq_parent(aq_inner(self))

        log.debug('removing package (%s) in queue'%pid)		
        queue.remove_package(package)
        
        log.debug('adding package (%s) to published packages'%pid)		
        package_container = self.get_inner_application(self, 2) 
        package_container.add_package(self.aq_parent.aq_base)

        # redirect back to queue
        if REQUEST is not None:
            REQUEST.RESPONSE.redirect(queue.absolute_url()+'?message='+pid+'+published')
        
    def package_add_version_file(self, REQUEST):
        """ """
        contract = """
        #parameters
        version_file:file
        file_type:trim, constraint(supported_file_types)
        platform:trim, constraint(supported_platforms)
        """
        #version_id:trim, obid(Versions)
        
        contract = compile(contract)
        
        # hmm.. err handling seems to trigger a bug... todo list for the moment
        errors = contract.validate(self, no_error_handling=1)
        if errors:
            return errors
        
        
        container = self.get_version_container()

        version = container._getOb(REQUEST['version_id'])
        
        id, title = cookId('','',REQUEST['version_file'])
        
        fobj= PackageFile(id, 
                          title, 
                          REQUEST['file_type'],
                          'tgz',
                          REQUEST['platform'])
        
        version.add_file(fobj)
        
        fobj = version._getOb(id)
        fobj.manage_upload(REQUEST['version_file'])
        
        REQUEST.RESPONSE.redirect('.')
        
    def package_create_version(self, REQUEST):
        """ create a new package version """
        contract = """
        #parameters
        version_id:trim
        """ 
        contract = compile(contract)
        contract.validate(self)
        
        version = PackageVersion(REQUEST['version_id'])
        version_container = self.get_version_container()        
        
        version_container.add_version(version)
        # hmm.. where to redirect        
        REQUEST.RESPONSE.redirect('.')
                                       

    def edit_package_versions(self, REQUEST):
        """ """
        
    def package_add_dependency(self, REQUEST):
        """ """
        
        
    def edit_package_info(self, REQUEST):
        """ """
        contract = """
        #parameters
        """
        contract = compile(contract)
        contract.validate(self)
        pass
    
    def edit_package_categories(self, REQUEST):
        """ """
        # need a constrainted list contract
        contract = """
        #parameters
        package_categories:trim
        """
        categories = REQUEST['package_categories']
        info = self.get_package_info()
        
        info.set_categories(categories)
        
        # event broadcast to listeners
        if self.get_package_info().is_published():        
            channel = self.get_service("EventChannel")
            channel.publish(self.aq_inner.aq_parent, "package categories modified")
        
        
        REQUEST.RESPONSE.redirect('.')