
from Products.Gideon.Objects.Namespace import *

class PackageVersionContainer(Folder):
	
	meta_type = 'Package Version Container'

	security = ClassSecurityInfo()
	
	index_html = None
	
	__call__ = DTMLFile('ui/PackageVersionContainerView', globals())
	
	security.declarePublic('version_list')
	version_list = DTMLFile('ui/PackageVersionContainerList', globals())
	
	def __init__(self, id):
		self.id = id
		self._cur_version = None
	
	def get_global_dependencies(self):
		return self.objectValues('Package Dependency')

	def add_global_dependency(self, depedency):
		self._setObject(depedency.getId(), depedency)

	def add_version(self, version):
		if self._cur_version is None: 
			self._cur_version = version.id
		self._setObject(version.id, version)

	def get_versions(self):
		return self.objectValues('Package Version')
	
	### hmm. ideally this is an ordered list 
	
	def set_current_version(self, vid):
		if vid in self.objectIds('Package Version'):
			self._cur_version = vid
		else: raise "Invalid Version Id"
		
	def get_current_version(self):
		if self._cur_version and self._cur_version in self.objectIds('Package Version'):
			return self._getOb(self._cur_version)
		elif self._cur_version is None and len(self.objectIds('Package Version')) ==1:
			return self.objectValues('Package Version')[0]
		elif self._cur_version is None and len(self.objectIds()) == 0:
			raise "No Versions"
		elif self._cur_version is None:
			raise "No current version Set"
		elif self._cur_version is not None:
			raise "Inconsistent Version State"


class PackageVersion(Folder, Implicit):
	
	"""
	a version logically consists of 
	distribution files, a version id/name,
	and version specific dependencies
	
	"""
	meta_type = 'Package Version'
	
	def __init__(self, id):
		self.id = id

	def get_remaining_required(self): 
		""" hook method for versions created directly
		via metadata files to enforce schema constraints"""
		
	def add_version_dependency(self, dependency):
		self._setObject(dependency.getId(), dependency)
		
	def get_dependencies(self):
		""" """
		return self.objectValues('Package Dependency')

	def get_dependencies(self):
		return self.objectValues('Package Dependency')
		
	def get_files(self):
		return self.objectValues(('File', 'Package File'))
	
	def has_file(self, fid):
		return fid in self.objectIds(('File', 'Package File'))
	
	def add_file(self, file): 
		self._setObject(file.getId(), file)
		#self.manage_addProduct['OFSP'].manage_addFile(id='', title='',file=file)
		
