#from Products.Gideon.Objects.Application.PythonRepository import RepositoryApplication 
#from Products.Gideon.Objects.Application import PythonRepository
#from Products.Gideon.Objects.Namespace import get_file_system
#from Products.Gideon.Common.Sequences import Sequence

# wierdness
from OFS.Folder import Folder
from Acquisition import Implicit
from OFS.SimpleItem import SimpleItem
#CatalogSchema = Gideon.Objects.Application.CatalogSchema
from Products.Gideon.PageContract.Scripts import compile
from Products.Gideon import FileSystem
from Products.Gideon import MetaDataParsers
from Products.Gideon.Log.Log import log
#from Products.Gideon.Objects.Namespace import *
from ComputedAttribute import ComputedAttribute
from BTrees.IOBTree import IOSet
from OFS.Image import cookId


## Page Contracts

metadata_creation_contract = """
#paramaters
package_name:nohtml,trim
author_name:optional,trim
author_email:optional,trim
maintainer_email:optional,trim
package_url:optional,trim
company:optional,trim
category:optional,trim
"""
				
metadata_upload_contract = """
#parameters
metadata_file:file
metadata_format:constraint(supported_formats)
"""

version_upload_contract = """
#parameters
distribution_file:file
"""



class PackageUpload(Folder):

	meta_type = "Package Upload"
	
	index_html = DTMLFile('ui/PackageUploadView', globals())
	metadata_upload_form = DTMLFile('ui/PackageMetadataUploadForm', globals())
	metadata_creation_form = DTMLFile('ui/PackageMetadataCreationForm', globals())
	metadata_required_form = DTMLFile('ui/PackagaMetadataRequiredForm', globals())
	metadata_edit_form = DTMLFile('ui/PackageMetadataEditForm', globals())
	version_creation_form = DTMLFile('ui/PackageVersionCreationForm', globals())
	version_edit_form = DTMLFile('ui/PackageVersionEditForm', globals())
	version_upload_form = DTMLFile('ui/PackageVersionUploadForm', globals())	
	
	def __init__(self,
			id,
			title):
		
		self.id = id
		self.title = title	 
		
	def get_supported_file_formats(self):
		return FileSystem.get_file_formats()
	
	def get_supported_metadata_formats(self):
		return MetaDataParsers.supported_formats()
	
	supported_formats = ComputedAttribute(get_supported_metadata_formats)
	
	def _parse_metadata_file(self, fmt, file):
		return MetaDataParsers.parse(fmt, 'stream', file)
		
	def version_upload_submit(self, REQUEST=None):
		""" """
		
		if REQUEST.has_key('package_name'):
			pkgid = REQUEST['package_name']
		else: raise "No Package Upload found for Session"
			
		contract = compile(version_upload_contract)
		contract.validate(self)
		
		package_queue = self.get_inner_application(self).get_package_queue()
		package = package_queue._getOb(pkgid)
		version = package.get_version_container().get_current_version()
		
		if not version.has_file(cookId('','',REQUEST['distribution_file'])):
			version.add_file(REQUEST['distribution_file'])

		return_url = self.get_inner_application(self).get_package_queue().absolute_url()			
		
		if REQUEST is not None:
			REQUEST.RESPONSE.redirect(return_url)


	def metadata_upload_submit(self, REQUEST):
		""" """
		contract = compile(metadata_upload_contract)
		contract.validate(self)
		
		rawinfo = self._parse_metadata_file(REQUEST['metadata_format'], REQUEST['metadata_file'])

		print rawinfo
		pi = PackageInfo(rawinfo)		
		p  = Package(pi.get_package_uid())
		pv = PackageVersion(rawinfo.get('version'))
		p.set_package_info(pi)

		# this whole thing is a mess right now
		# it needs to reworked, packages shouldn't 
		# be added to the queue unless they have all
		# the req info. however doing some of the
		# object addition while in non rooted is
		# difficult for zope objects
		
		log.debug('Storing Package in Queue')		
		package_container = self.get_inner_application(self)
		package_container.add_package_to_queue(p)		

		p.get_version_container().add_version(pv)
		
		info_required = pi.get_remaining_required()
		version_required = pv.get_remaining_required()
		
		if info_required is None and version_required is None:

			package_queue = package_container.get_package_queue()			
			
			redirect_url = ']'.join((package_queue.absolute_url(),
							         pi.get_package_uid(),
							         'version_upload_form'
							         ))
			
			REQUEST.RESPONSE.redirect('version_upload_form'+'?package_name='+\
							pi.get_package_uid())
			
		elif info_required is None and version_required is not None:
			REQUEST.RESPONSE.redirect('version_required_form')			
		elif info_required is not None:
			REQUEST.RESPONSE.redirect('metadata_required_form')						
		else: log.debug('Upload Error, shouldn" have gotten here')


		
class PackageFolder(Folder):		
	meta_type = 'Package Folder'
	index_html = DTMLFile('ui/PackageFolderView', globals())
	

# create a package with author, info, version, and workflow in the queue

class PackageAdmin(SimpleItem, Implicit):
	""" adminstrative interface, this should
    contain most of the state dependent behavior, its a kludge
	and i know it.	"""

	def __init__(self,
			     id = 'Admin'
			):
		self.id = id
		self._state = ''

	def get_admin_actions(self):
		pass

			
			




	



from PackageInfo import PackageInfo
from PackageVersion import PackageVersion, PackageVersionContainer
		
	
