"""
 (C) Copyright 2002 Kapil Thangavelu <kvthan@wm.edu>
 All Rights Reserved

 This file is part of Gideon.

 Gideon is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Gideon is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Gideon; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""

# $Id: $

from Products.Gideon.Objects.Namespace import *

class IServiceAdaptor(Base):
    
    def protocol(self):
        """ 
        return the procotol the adaptor services
        """
        
class ServiceAdaptor(SimpleItem):
    
    meta_type = 'Service Adaptor'
    
    __implements__ = (IServiceAdaptor,)
    
    _protocol = None
    
    def __init__(self, id):
        self.id = id

    def protocol(self):
        return self._protocol
        
    def manage_afterAdd(self, item, container):
        """ """
        broker = self.get_inner_application(self)
        broker.register_adaptor(self, self._protocol)
        

class XMLRPCServiceAdaptor(ServiceAdaptor):
    
    _protocol = 'XMLRPC'
    
    def __bobo_traverse__(self, REQUEST, name=None):
        
        provider = self.get_inner_application(self).get_provider(method_name=name)
        
        if provider is not None:
            return getattr(provider, name)

        return getattr(self, name)

    
    def search_packages(self, query):
        """ """
        ## check the query
        return 1


class SOAPServiceAdaptor(ServiceAdaptor):
    
    _protocol = 'SOAP'
    
class SwallowServiceAdaptor(ServiceAdaptor):
    
    _protocol = 'Swallow'
    
    
    