"""
 (C) Copyright 2002 Kapil Thangavelu <kvthan@wm.edu>
 All Rights Reserved

 This file is part of Gideon.

 Gideon is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Gideon is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Gideon; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""

# $Id: $

from ZODB.PersistentMapping import PersistentMapping

from Products.Gideon.Objects.Namespace import *
from Products.Gideon.Log.Log import log


class IServiceProvider(Base):
    
    def methods(self):
        """ return the method names this provider provides """
        
        
class ServiceProvider(SimpleItem):
    
    meta_type = 'Service Provider'
    
    __implements__ = (IServiceProvider,)

    _methods = ()
    
    def __init__(self, id):
        self.id = id
        
    def manage_afterAdd(self, item, container):
        broker = self.get_inner_application(self)
        broker.register_provider(self, self._methods)

class RepositoryServiceProvider(ServiceProvider):
    
    _methods = ('search_packages',
                'get_package_info',
                'get_author_info')

    def search_packages(self, query=None, REQUEST=None):
        """ """
        
        REQUEST.form['SearchableText']=query
        package_container = self.get_application_for_name("Packages")
        
        res = package_container.search_packages(REQUEST)
        
        return [r.package_name for r in res]
    
    def get_package_info(self, pkgid):
        """ """
        return 2
    
    def get_author_info(self, authorid):
        """ """
        return 3
    

