"""
 (C) Copyright 2002 Kapil Thangavelu <kvthan@wm.edu>
 All Rights Reserved

 This file is part of Gideon.

 Gideon is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Gideon is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Gideon; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""

# $Id: $

from Products.Gideon.Objects.Namespace import *
from Products.Gideon.Objects.BTreeUser.Collaborators import BaseCollaborator

import inspect

class SubscriptionDelegate(ObjectManager):
    """
    This class provides a useful interaction between users and 
    objects they wish to subscribe to by providing context methods
    for subscription.
    """
    
    meta_type = 'Subscription Delegate'
    
    
    def subscribe_object(self, REQUEST):
        pass
    
    
class _SubscriptionFilterRegistry:

    def __init__(self):
        self._filters = {}
      
    def add_filter(self, name, filter):
        self._filters[name]=filter
    
    def get_filter(self, name):
        return self._filters.get(name)
        
    def get_filter_doc(self, name):
        return inspect.getdoc(self._filters.get(name))
    
    def list_filters(self):
        return self._filters.keys()
        
FilterRegistry = _SubscriptionFilterRegistry()
del _SubscriptionFilterRegistry

register_filter = FilterRegistry.add_filter
get_filter = FilterRegistry.get_filter
get_filter_docs = FilterRegistry.get_filter_doc
list_filters = FilterRegistry.list_filters

def category_filter(self, event_type): pass
    
class SubscriptionManager(BaseCollaborator):
    
    security = ClassSecurityInfo()
    
    meta_type = 'Subscriptions Collaborator'

    _default_panel_name = 'subscription_panel'
    _default_widget_name = 'subscription_widget'    
    
    _default_panel_name = 'subscription_panel'
    _default_widget_name = 'subscription_widget'
    
    subscription_panel = DTMLFile('ui/SubscriptionCollaboratorView', globals())
    subscription_widget = DTMLFile('ui/SubscriptionCollaboratorWidget', globals())
        
    def add_subscription(self, REQUEST): pass
    def remove_subscription(self, REQUEST): pass
    def get_subscriptions(self): pass
    
class Subscription(SimpleItem, Implicit):
    
    meta_type = 'Subscription'
    
    security = ClassSecurityInfo()
    
    def __init__(self, event_type, filter_name):
        self._active = 1
        self._filter_name = filter_kind
        
    def activate(self): 
        self._active = 1

    def inactivate(self): 
        self._active = 1
        
    def get_history(self): pass
    
    
    
    